# ngApiHandler
 
An **AngularJS** module for use all Google Apis and your Google Cloud Endpoints (Google App Engine) Using   [angular gapi](https://github.com/maximepvrt/angular-google-gapi) , For Encapsulation.


## Requirements

- [Angular.js](http://angularjs.org)
- [angular-google-gapi](https://github.com/maximepvrt/angular-google-gapi)

## Installation
### Add library
This module is available as bower package, install it with this command:

```bash
bower install ng-api-handler
```

and it's available too as npm package, install it with this command:

```bash
npm install ng-api-handler
```

or you may download the [latest release](https://github.com/theo4u/ngApiHandler/releases)

### Include library
```html
<script type="text/javascript" src="/ng-api-handler/dist/angular-google-gapi.min.js"></script>
```
### Add dependency

```javascript
var app = angular.module('myModule', ['ngApiHandler']);
```

## Configuration
### without Google Auth

add run in root module

```javascript
app.run(['ApiHandler',
  function(ApiHandler) {
   ApiHandler.connectApi('myApiName','v1');//calling this for access to get all method from the myApiName class api
     }
          ]);
```

## Use

### Execute our api 

```javascript
app.controller('myController', ['$scope', 'ApiHandler',
    function myController($scope, ApiHandler) {
    param={};//or {item:value[,item1:value1]}
      	ApiHandler.callService('myApiName', 'you.api.method.name',param}).then( function(resp) {
               //success
                console.info(resp);
	}, function(err) {
	//failure
		console.error(err);
	});
    }
]);
```
