/**
 * Created by SQ04 Theophilus Omoregbee <theo4u@ymail.com> on 6/29/2016.
 */


var apiHandler = angular.module('ngApiHandler', ['angular-google-gapi']);

/**
 *
 *  Constants implementataion by I.Tyger <i.tyger@rareatom.com> [https://gitlab.com/u/tyger2007]
 *   Constants to handle core properties
 */
apiHandler.constant('apiHandlerConstants', {

    ENDPOINT_URL : 'http://localhost:8080/_ah/api',
    CLIENT_KEY :'AIzaSyAR4P_CsjDaK2QTlM25Semf30Bg1PLALPI',
    BLOB_UPLOAD_URL:'http://localhost:8080/blob_service_initiate_servlet',
    SERVE_BLOB: 'http://localhost:8080/serve?blob-key='

});

apiHandler.factory('ApiHandler',['$log','GApi','GAuth','apiHandlerConstants','$http',function ($log, GApi, GAuth, apiHandlerConstants,$http)
{
    /**
     * To help us handle any interaction to the server side
     */

    /**
     * Declaring functions
     */
    return {
        /**
         *
         * @param serviceApi to link which api service module to read information from
         * @param serviceMethod the actual service to interact with , contained inside the parent module
         * @param param the parameters to pass to the service as argument to process response
         */
        callService:function (serviceApi,serviceMethod,param) {
            return  GApi.execute(serviceApi, serviceMethod, param);
        },
        //end callService Function

        /**
         *
         * @param serviceApi  to link which api service module to load information from
         * @param version to notify which version to load for us from our server (specific to @param serviceApi)
         */
        connectApi: function (serviceApi,version) {
            GAuth.setClient(apiHandlerConstants.CLIENT_KEY);
            GApi.load(serviceApi,version,apiHandlerConstants.ENDPOINT_URL).then(function(resp) {
                console.info('api: ' + resp.api + ', version: ' + resp.version + ' loaded');
            }, function(resp) {
                console.error('an error occured during loading api: ' + resp.api + ', resp.version: ' + version);
            });
        },
        getBaseUrl:apiHandlerConstants.ENDPOINT_URL,
        getClientKey:apiHandlerConstants.CLIENT_KEY,
        getUploadUrl: apiHandlerConstants.BLOB_UPLOAD_URL,
        getServeBlobUrl: apiHandlerConstants.SERVE_BLOB
    }



}]);
